/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_common/pr2_msgs/msg/AccelerometerState.msg.  Do not edit! */
#ifndef PR2_MSGS_ACCELEROMETERSTATE_H
#define PR2_MSGS_ACCELEROMETERSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Vector3.h"

namespace pr2_msgs
{

//! \htmlinclude AccelerometerState.msg.html

class AccelerometerState : public ros::Message
{
public:
  typedef boost::shared_ptr<AccelerometerState> Ptr;
  typedef boost::shared_ptr<AccelerometerState const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<geometry_msgs::Vector3> _samples_type;

  roslib::Header header;
  std::vector<geometry_msgs::Vector3> samples;

  AccelerometerState() : ros::Message()
  {
  }
  AccelerometerState(const AccelerometerState &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    samples = copy.samples;
  }
  AccelerometerState &operator =(const AccelerometerState &copy)
  {
    if (this == &copy)
      return *this;
    samples.clear();
    header = copy.header;
    samples = copy.samples;
    return *this;
  }
  virtual ~AccelerometerState() 
  {
    samples.clear();
  }
  inline static std::string __s_getDataType() { return std::string("pr2_msgs/AccelerometerState"); }
  inline static std::string __s_getMD5Sum() { return std::string("26492e97ed8c13252c4a85592d3e93fd"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "#This captures acceleration measurements from the 3-dof accelerometer in the hand of the PR2\n"
    "#Units are meters / second / second\n"
    "#Vectors should be <X, Y, Z> in the frame of the gripper\n"
    "\n"
    "#The communication with the accelerometer is at approximately 3khz, but there is only good timestamping every 1ms\n"
    "#This means the samples should be interpreted as all having come from the 1 ms before the time in the header\n"
    "\n"
    "Header header\n"
    "geometry_msgs/Vector3[] samples\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_samples_size(uint32_t __ros_new_size)
  {
    this->samples.resize(__ros_new_size);
  }
  inline uint32_t get_samples_size() const { return samples.size(); }
  inline void get_samples_vec (std::vector<geometry_msgs::Vector3> &__ros_vec) const
  {
    __ros_vec = this->samples;
  }
  inline void set_samples_vec(const std::vector<geometry_msgs::Vector3> &__ros_vec)
  {
    this->samples = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + (samples.size() ? samples.size() * samples[0].serializationLength() : 0); // samples
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __samples_size = samples.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __samples_size);
    for (size_t i = 0; i < __samples_size; i++)
      write_ptr = samples[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __samples_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __samples_size);
    set_samples_size(__samples_size);
    for (size_t i = 0; i < __samples_size; i++)
      read_ptr = samples[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<AccelerometerState> AccelerometerStatePtr;
typedef boost::shared_ptr<AccelerometerState const> AccelerometerStateConstPtr;


}

#endif
