/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_common/pr2_msgs/msg/BatteryServer.msg.  Do not edit! */
#ifndef PR2_MSGS_BATTERYSERVER_H
#define PR2_MSGS_BATTERYSERVER_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "pr2_msgs/BatteryState.h"

namespace pr2_msgs
{

//! \htmlinclude BatteryServer.msg.html

class BatteryServer : public ros::Message
{
public:
  typedef boost::shared_ptr<BatteryServer> Ptr;
  typedef boost::shared_ptr<BatteryServer const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef int32_t _id_type;
  typedef int32_t _lastTimeSystem_type;
  typedef uint16_t _timeLeft_type;
  typedef uint16_t _averageCharge_type;
  typedef std::string _message_type;
  typedef int32_t _lastTimeController_type;
  typedef uint16_t _present_type;
  typedef uint16_t _charging_type;
  typedef uint16_t _discharging_type;
  typedef uint16_t _reserved_type;
  typedef uint16_t _powerPresent_type;
  typedef uint16_t _powerNG_type;
  typedef uint16_t _inhibited_type;
  typedef std::vector<pr2_msgs::BatteryState> _battery_type;

  roslib::Header header;
  const static uint32_t MAX_BAT_COUNT = 4;
  const static uint32_t MAX_BAT_REG = 48;
  int32_t id;
  int32_t lastTimeSystem;
  uint16_t timeLeft;
  uint16_t averageCharge;
  std::string message;
  int32_t lastTimeController;
  uint16_t present;
  uint16_t charging;
  uint16_t discharging;
  uint16_t reserved;
  uint16_t powerPresent;
  uint16_t powerNG;
  uint16_t inhibited;
  std::vector<pr2_msgs::BatteryState> battery;

  BatteryServer() : ros::Message(),
    id(0),
    lastTimeSystem(0),
    timeLeft(0),
    averageCharge(0),
    lastTimeController(0),
    present(0),
    charging(0),
    discharging(0),
    reserved(0),
    powerPresent(0),
    powerNG(0),
    inhibited(0)
  {
  }
  BatteryServer(const BatteryServer &copy) : ros::Message(),
    header(copy.header),
    id(copy.id),
    lastTimeSystem(copy.lastTimeSystem),
    timeLeft(copy.timeLeft),
    averageCharge(copy.averageCharge),
    message(copy.message),
    lastTimeController(copy.lastTimeController),
    present(copy.present),
    charging(copy.charging),
    discharging(copy.discharging),
    reserved(copy.reserved),
    powerPresent(copy.powerPresent),
    powerNG(copy.powerNG),
    inhibited(copy.inhibited)
  {
    (void)copy;
    battery = copy.battery;
  }
  BatteryServer &operator =(const BatteryServer &copy)
  {
    if (this == &copy)
      return *this;
    battery.clear();
    header = copy.header;
    id = copy.id;
    lastTimeSystem = copy.lastTimeSystem;
    timeLeft = copy.timeLeft;
    averageCharge = copy.averageCharge;
    message = copy.message;
    lastTimeController = copy.lastTimeController;
    present = copy.present;
    charging = copy.charging;
    discharging = copy.discharging;
    reserved = copy.reserved;
    powerPresent = copy.powerPresent;
    powerNG = copy.powerNG;
    inhibited = copy.inhibited;
    battery = copy.battery;
    return *this;
  }
  virtual ~BatteryServer() 
  {
    battery.clear();
  }
  inline static std::string __s_getDataType() { return std::string("pr2_msgs/BatteryServer"); }
  inline static std::string __s_getMD5Sum() { return std::string("4f6d6e54c9581beb1df7ea408c0727be"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# DEPRECATED. Use pr2_msgs/BatteryServer2 instead.\n"
    "Header header\n"
    "uint32 MAX_BAT_COUNT=4\n"
    "uint32 MAX_BAT_REG=48\n"
    "int32 id  # unique ID for each battery server\n"
    "# Battery System Stats\n"
    "int32 lastTimeSystem #epoch time\n"
    "uint16 timeLeft      # in minutes\n"
    "uint16 averageCharge # in percent\n"
    "string message\n"
    "# Battery Controller Flags\n"
    "int32 lastTimeController #epoch time\n"
    "uint16 present\n"
    "uint16 charging\n"
    "uint16 discharging\n"
    "uint16 reserved\n"
    "uint16 powerPresent\n"
    "uint16 powerNG\n"
    "uint16 inhibited\n"
    "# for each battery\n"
    "pr2_msgs/BatteryState[] battery\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: pr2_msgs/BatteryState\n"
    "# DEPRECATED.  Use pr2_msgs/BatteryState2 instead.\n"
    "# Each batteries registers\n"
    "int32 lastTimeBattery #epoch time\n"
    "uint16[48] batReg\n"
    "uint16[48] batRegFlag\n"
    "int32[48] batRegTime\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_battery_size(uint32_t __ros_new_size)
  {
    this->battery.resize(__ros_new_size);
  }
  inline uint32_t get_battery_size() const { return battery.size(); }
  inline void get_battery_vec (std::vector<pr2_msgs::BatteryState> &__ros_vec) const
  {
    __ros_vec = this->battery;
  }
  inline void set_battery_vec(const std::vector<pr2_msgs::BatteryState> &__ros_vec)
  {
    this->battery = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 0; // MAX_BAT_COUNT
    __l += 0; // MAX_BAT_REG
    __l += 4; // id
    __l += 4; // lastTimeSystem
    __l += 2; // timeLeft
    __l += 2; // averageCharge
    __l += 4 + message.length(); // message
    __l += 4; // lastTimeController
    __l += 2; // present
    __l += 2; // charging
    __l += 2; // discharging
    __l += 2; // reserved
    __l += 2; // powerPresent
    __l += 2; // powerNG
    __l += 2; // inhibited
    __l += 4 + (battery.size() ? battery.size() * battery[0].serializationLength() : 0); // battery
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, id);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, lastTimeSystem);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, timeLeft);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, averageCharge);
    unsigned __ros_message_len = message.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_message_len);
    SROS_SERIALIZE_BUFFER(write_ptr, message.c_str(), __ros_message_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, lastTimeController);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, present);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, charging);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, discharging);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, reserved);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, powerPresent);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, powerNG);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, inhibited);
    uint32_t __battery_size = battery.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __battery_size);
    for (size_t i = 0; i < __battery_size; i++)
      write_ptr = battery[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, id);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, lastTimeSystem);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, timeLeft);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, averageCharge);
    unsigned __ros_message_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_message_len);
    message = std::string((const char *)read_ptr, __ros_message_len);
    read_ptr += __ros_message_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, lastTimeController);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, present);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, charging);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, discharging);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, reserved);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, powerPresent);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, powerNG);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, inhibited);
    uint32_t __battery_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __battery_size);
    set_battery_size(__battery_size);
    for (size_t i = 0; i < __battery_size; i++)
      read_ptr = battery[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<BatteryServer> BatteryServerPtr;
typedef boost::shared_ptr<BatteryServer const> BatteryServerConstPtr;


}

#endif
