/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_common/pr2_msgs/msg/BatteryServer2.msg.  Do not edit! */
#ifndef PR2_MSGS_BATTERYSERVER2_H
#define PR2_MSGS_BATTERYSERVER2_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "pr2_msgs/BatteryState2.h"

namespace pr2_msgs
{

//! \htmlinclude BatteryServer2.msg.html

class BatteryServer2 : public ros::Message
{
public:
  typedef boost::shared_ptr<BatteryServer2> Ptr;
  typedef boost::shared_ptr<BatteryServer2 const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef int32_t _id_type;
  typedef ros::Time _last_system_update_type;
  typedef ros::Duration _time_left_type;
  typedef int32_t _average_charge_type;
  typedef std::string _message_type;
  typedef ros::Time _last_controller_update_type;
  typedef std::vector<pr2_msgs::BatteryState2> _battery_type;

  roslib::Header header;
  const static int32_t MAX_BAT_COUNT = 4;
  const static int32_t MAX_BAT_REG = 48;
  int32_t id;
  ros::Time last_system_update;
  ros::Duration time_left;
  int32_t average_charge;
  std::string message;
  ros::Time last_controller_update;
  std::vector<pr2_msgs::BatteryState2> battery;

  BatteryServer2() : ros::Message(),
    id(0),
    average_charge(0)
  {
  }
  BatteryServer2(const BatteryServer2 &copy) : ros::Message(),
    header(copy.header),
    id(copy.id),
    last_system_update(copy.last_system_update),
    time_left(copy.time_left),
    average_charge(copy.average_charge),
    message(copy.message),
    last_controller_update(copy.last_controller_update)
  {
    (void)copy;
    battery = copy.battery;
  }
  BatteryServer2 &operator =(const BatteryServer2 &copy)
  {
    if (this == &copy)
      return *this;
    battery.clear();
    header = copy.header;
    id = copy.id;
    last_system_update = copy.last_system_update;
    time_left = copy.time_left;
    average_charge = copy.average_charge;
    message = copy.message;
    last_controller_update = copy.last_controller_update;
    battery = copy.battery;
    return *this;
  }
  virtual ~BatteryServer2() 
  {
    battery.clear();
  }
  inline static std::string __s_getDataType() { return std::string("pr2_msgs/BatteryServer2"); }
  inline static std::string __s_getMD5Sum() { return std::string("5f2cec7d06c312d756189db96c1f3819"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message communicates the state of a battery server, which controls\n"
    "# multiple batteries.\n"
    "Header header\n"
    "int32 MAX_BAT_COUNT=4\n"
    "int32 MAX_BAT_REG=48\n"
    "int32 id  # unique ID for each battery server\n"
    "# Battery System Stats\n"
    "time last_system_update  # last time the system stats where updated\n"
    "duration time_left       # in seconds (hardware resolution is 1 minute)\n"
    "int32 average_charge     # in percent\n"
    "string message           # message from the ocean server\n"
    "time last_controller_update # last time a battery status flag was updated\n"
    "# for each battery\n"
    "pr2_msgs/BatteryState2[] battery\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: pr2_msgs/BatteryState2\n"
    "# This message communicates the state of a single battery.\n"
    "# Battery Controller Flags, one per battery\n"
    "bool present       # is this pack present\n"
    "bool charging      # is this pack charging\n"
    "bool discharging   # is this pack discharging\n"
    "bool power_present # is there an input voltage\n"
    "bool power_no_good # is there a fault (No Good)\n"
    "bool inhibited     # is this pack disabled for some reason\n"
    "# These registers are per battery\n"
    "time      last_battery_update     # last time any battery update occurred\n"
    "int16[48] battery_register        # value of this register in the battery\n"
    "bool[48]  battery_update_flag     # Has this register ever been updated\n"
    "time[48]  battery_register_update # last time this specific register was updated\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_battery_size(uint32_t __ros_new_size)
  {
    this->battery.resize(__ros_new_size);
  }
  inline uint32_t get_battery_size() const { return battery.size(); }
  inline void get_battery_vec (std::vector<pr2_msgs::BatteryState2> &__ros_vec) const
  {
    __ros_vec = this->battery;
  }
  inline void set_battery_vec(const std::vector<pr2_msgs::BatteryState2> &__ros_vec)
  {
    this->battery = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 0; // MAX_BAT_COUNT
    __l += 0; // MAX_BAT_REG
    __l += 4; // id
    __l += 8; // last_system_update
    __l += 8; // time_left
    __l += 4; // average_charge
    __l += 4 + message.length(); // message
    __l += 8; // last_controller_update
    __l += 4 + (battery.size() ? battery.size() * battery[0].serializationLength() : 0); // battery
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, id);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_system_update.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_system_update.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, time_left.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, time_left.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, average_charge);
    unsigned __ros_message_len = message.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_message_len);
    SROS_SERIALIZE_BUFFER(write_ptr, message.c_str(), __ros_message_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_controller_update.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_controller_update.nsec);
    uint32_t __battery_size = battery.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __battery_size);
    for (size_t i = 0; i < __battery_size; i++)
      write_ptr = battery[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, id);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_system_update.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_system_update.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_left.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_left.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, average_charge);
    unsigned __ros_message_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_message_len);
    message = std::string((const char *)read_ptr, __ros_message_len);
    read_ptr += __ros_message_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_controller_update.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_controller_update.nsec);
    uint32_t __battery_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __battery_size);
    set_battery_size(__battery_size);
    for (size_t i = 0; i < __battery_size; i++)
      read_ptr = battery[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<BatteryServer2> BatteryServer2Ptr;
typedef boost::shared_ptr<BatteryServer2 const> BatteryServer2ConstPtr;


}

#endif
