/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_common/pr2_msgs/msg/BatteryState2.msg.  Do not edit! */
#ifndef PR2_MSGS_BATTERYSTATE2_H
#define PR2_MSGS_BATTERYSTATE2_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace pr2_msgs
{

//! \htmlinclude BatteryState2.msg.html

class BatteryState2 : public ros::Message
{
public:
  typedef boost::shared_ptr<BatteryState2> Ptr;
  typedef boost::shared_ptr<BatteryState2 const> ConstPtr;

  typedef uint8_t _present_type;
  typedef uint8_t _charging_type;
  typedef uint8_t _discharging_type;
  typedef uint8_t _power_present_type;
  typedef uint8_t _power_no_good_type;
  typedef uint8_t _inhibited_type;
  typedef ros::Time _last_battery_update_type;
  typedef boost::array<int16_t, 48> _battery_register_type;
  typedef boost::array<uint8_t, 48> _battery_update_flag_type;
  typedef boost::array<ros::Time, 48> _battery_register_update_type;

  uint8_t present;
  uint8_t charging;
  uint8_t discharging;
  uint8_t power_present;
  uint8_t power_no_good;
  uint8_t inhibited;
  ros::Time last_battery_update;
  boost::array<int16_t, 48> battery_register;
  boost::array<uint8_t, 48> battery_update_flag;
  boost::array<ros::Time, 48> battery_register_update;

  BatteryState2() : ros::Message(),
    present(0),
    charging(0),
    discharging(0),
    power_present(0),
    power_no_good(0),
    inhibited(0)
  {
    battery_register.assign(0);
    battery_update_flag.assign(0);
  }
  BatteryState2(const BatteryState2 &copy) : ros::Message(),
    present(copy.present),
    charging(copy.charging),
    discharging(copy.discharging),
    power_present(copy.power_present),
    power_no_good(copy.power_no_good),
    inhibited(copy.inhibited),
    last_battery_update(copy.last_battery_update)
  {
    (void)copy;
    battery_register = copy.battery_register;
    battery_update_flag = copy.battery_update_flag;
    battery_register_update = copy.battery_register_update;
  }
  BatteryState2 &operator =(const BatteryState2 &copy)
  {
    if (this == &copy)
      return *this;
    present = copy.present;
    charging = copy.charging;
    discharging = copy.discharging;
    power_present = copy.power_present;
    power_no_good = copy.power_no_good;
    inhibited = copy.inhibited;
    last_battery_update = copy.last_battery_update;
    battery_register = copy.battery_register;
    battery_update_flag = copy.battery_update_flag;
    battery_register_update = copy.battery_register_update;
    return *this;
  }
  virtual ~BatteryState2() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_msgs/BatteryState2"); }
  inline static std::string __s_getMD5Sum() { return std::string("91b4acb000aa990ac3006834f9a99669"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message communicates the state of a single battery.\n"
    "# Battery Controller Flags, one per battery\n"
    "bool present       # is this pack present\n"
    "bool charging      # is this pack charging\n"
    "bool discharging   # is this pack discharging\n"
    "bool power_present # is there an input voltage\n"
    "bool power_no_good # is there a fault (No Good)\n"
    "bool inhibited     # is this pack disabled for some reason\n"
    "# These registers are per battery\n"
    "time      last_battery_update     # last time any battery update occurred\n"
    "int16[48] battery_register        # value of this register in the battery\n"
    "bool[48]  battery_update_flag     # Has this register ever been updated\n"
    "time[48]  battery_register_update # last time this specific register was updated\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t get_battery_register_size() const { return 48; }
  inline uint32_t get_battery_update_flag_size() const { return 48; }
  inline uint32_t get_battery_register_update_size() const { return 48; }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 1; // present
    __l += 1; // charging
    __l += 1; // discharging
    __l += 1; // power_present
    __l += 1; // power_no_good
    __l += 1; // inhibited
    __l += 8; // last_battery_update
    __l += 48 * 2; // battery_register
    __l += 48 * 1; // battery_update_flag
    __l += 48 * 8; // battery_register_update
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, present);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, charging);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, discharging);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, power_present);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, power_no_good);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, inhibited);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_battery_update.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_battery_update.nsec);
    memcpy(write_ptr, &battery_register[0], sizeof(int16_t) * 48);
    write_ptr += sizeof(int16_t) * 48;
    memcpy(write_ptr, &battery_update_flag[0], sizeof(uint8_t) * 48);
    write_ptr += sizeof(uint8_t) * 48;
    for (size_t i = 0; i < 48; i++)
    {
      SROS_SERIALIZE_PRIMITIVE(write_ptr, battery_register_update[i].sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, battery_register_update[i].nsec);
    }
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, present);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, charging);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, discharging);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, power_present);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, power_no_good);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, inhibited);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_battery_update.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_battery_update.nsec);
    memcpy(&battery_register[0], read_ptr, sizeof(int16_t) * 48);
    read_ptr += sizeof(int16_t) * 48;
    memcpy(&battery_update_flag[0], read_ptr, sizeof(uint8_t) * 48);
    read_ptr += sizeof(uint8_t) * 48;
    for (size_t i = 0; i < 48; i++)
    {
      SROS_DESERIALIZE_PRIMITIVE(read_ptr, battery_register_update[i].sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, battery_register_update[i].nsec);
    }
    return read_ptr;
  }
};

typedef boost::shared_ptr<BatteryState2> BatteryState2Ptr;
typedef boost::shared_ptr<BatteryState2 const> BatteryState2ConstPtr;


}

#endif
