/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_common/pr2_msgs/msg/LaserTrajCmd.msg.  Do not edit! */
#ifndef PR2_MSGS_LASERTRAJCMD_H
#define PR2_MSGS_LASERTRAJCMD_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"

namespace pr2_msgs
{

//! \htmlinclude LaserTrajCmd.msg.html

class LaserTrajCmd : public ros::Message
{
public:
  typedef boost::shared_ptr<LaserTrajCmd> Ptr;
  typedef boost::shared_ptr<LaserTrajCmd const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _profile_type;
  typedef std::vector<double> _position_type;
  typedef std::vector<ros::Duration> _time_from_start_type;
  typedef double _max_velocity_type;
  typedef double _max_acceleration_type;

  roslib::Header header;
  std::string profile;
  std::vector<double> position;
  std::vector<ros::Duration> time_from_start;
  double max_velocity;
  double max_acceleration;

  LaserTrajCmd() : ros::Message(),
    max_velocity(0),
    max_acceleration(0)
  {
  }
  LaserTrajCmd(const LaserTrajCmd &copy) : ros::Message(),
    header(copy.header),
    profile(copy.profile),
    max_velocity(copy.max_velocity),
    max_acceleration(copy.max_acceleration)
  {
    (void)copy;
    position = copy.position;
    time_from_start = copy.time_from_start;
  }
  LaserTrajCmd &operator =(const LaserTrajCmd &copy)
  {
    if (this == &copy)
      return *this;
    position.clear();
    time_from_start.clear();
    header = copy.header;
    profile = copy.profile;
    position = copy.position;
    time_from_start = copy.time_from_start;
    max_velocity = copy.max_velocity;
    max_acceleration = copy.max_acceleration;
    return *this;
  }
  virtual ~LaserTrajCmd() 
  {
    position.clear();
    time_from_start.clear();
  }
  inline static std::string __s_getDataType() { return std::string("pr2_msgs/LaserTrajCmd"); }
  inline static std::string __s_getMD5Sum() { return std::string("68a1665e9079049dce55a0384cb2e9b5"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message is used to set the profile that the tilt laser controller\n"
    "# executes.\n"
    "Header header\n"
    "string profile              # options are currently \"linear\" or \"linear_blended\"\n"
    "float64[] position          # Laser positions\n"
    "duration[] time_from_start  # Times to reach laser positions in seconds\n"
    "float64 max_velocity        # Set <= 0 to use default\n"
    "float64 max_acceleration    # Set <= 0 to use default\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_position_size(uint32_t __ros_new_size)
  {
    this->position.resize(__ros_new_size);
  }
  inline uint32_t get_position_size() const { return position.size(); }
  inline void get_position_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->position;
  }
  inline void set_position_vec(const std::vector<double> &__ros_vec)
  {
    this->position = __ros_vec;
  }
  void set_time_from_start_size(uint32_t __ros_new_size)
  {
    this->time_from_start.resize(__ros_new_size);
  }
  inline uint32_t get_time_from_start_size() const { return time_from_start.size(); }
  inline void get_time_from_start_vec (std::vector<ros::Duration> &__ros_vec) const
  {
    __ros_vec = this->time_from_start;
  }
  inline void set_time_from_start_vec(const std::vector<ros::Duration> &__ros_vec)
  {
    this->time_from_start = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + profile.length(); // profile
    __l += 4 + (position.size() ? position.size() * 8 : 0); // position
    __l += 4 + (time_from_start.size() ? time_from_start.size() * 8 : 0); // time_from_start
    __l += 8; // max_velocity
    __l += 8; // max_acceleration
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_profile_len = profile.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_profile_len);
    SROS_SERIALIZE_BUFFER(write_ptr, profile.c_str(), __ros_profile_len);
    uint32_t __position_size = position.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __position_size);
    memcpy(write_ptr, &position[0], sizeof(double) * __position_size);
    write_ptr += sizeof(double) * __position_size;
    uint32_t __time_from_start_size = time_from_start.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __time_from_start_size);
    for (size_t i = 0; i < __time_from_start_size; i++)
    {
      SROS_SERIALIZE_PRIMITIVE(write_ptr, time_from_start[i].sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, time_from_start[i].nsec);
    }
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_velocity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_acceleration);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_profile_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_profile_len);
    profile = std::string((const char *)read_ptr, __ros_profile_len);
    read_ptr += __ros_profile_len;
    uint32_t __position_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __position_size);
    set_position_size(__position_size);
    memcpy(&position[0], read_ptr, sizeof(double) * __position_size);
    read_ptr += sizeof(double) * __position_size;
    uint32_t __time_from_start_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __time_from_start_size);
    set_time_from_start_size(__time_from_start_size);
    for (size_t i = 0; i < __time_from_start_size; i++)
    {
      SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_from_start[i].sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_from_start[i].nsec);
    }
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_velocity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_acceleration);
    return read_ptr;
  }
};

typedef boost::shared_ptr<LaserTrajCmd> LaserTrajCmdPtr;
typedef boost::shared_ptr<LaserTrajCmd const> LaserTrajCmdConstPtr;


}

#endif
