/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_common/pr2_msgs/msg/PowerBoardState.msg.  Do not edit! */
#ifndef PR2_MSGS_POWERBOARDSTATE_H
#define PR2_MSGS_POWERBOARDSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"

namespace pr2_msgs
{

//! \htmlinclude PowerBoardState.msg.html

class PowerBoardState : public ros::Message
{
public:
  typedef boost::shared_ptr<PowerBoardState> Ptr;
  typedef boost::shared_ptr<PowerBoardState const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _name_type;
  typedef uint32_t _serial_num_type;
  typedef double _input_voltage_type;
  typedef int8_t _master_state_type;
  typedef boost::array<int8_t, 3> _circuit_state_type;
  typedef boost::array<double, 3> _circuit_voltage_type;
  typedef uint8_t _run_stop_type;
  typedef uint8_t _wireless_stop_type;

  const static int8_t STATE_NOPOWER = 0;
  const static int8_t STATE_STANDBY = 1;
  const static int8_t STATE_PUMPING = 2;
  const static int8_t STATE_ON = 3;
  const static int8_t STATE_ENABLED = 3;
  const static int8_t STATE_DISABLED = 4;
  const static int8_t MASTER_NOPOWER = 0;
  const static int8_t MASTER_STANDBY = 1;
  const static int8_t MASTER_ON = 2;
  const static int8_t MASTER_OFF = 3;
  const static int8_t MASTER_SHUTDOWN = 4;
  roslib::Header header;
  std::string name;
  uint32_t serial_num;
  double input_voltage;
  int8_t master_state;
  boost::array<int8_t, 3> circuit_state;
  boost::array<double, 3> circuit_voltage;
  uint8_t run_stop;
  uint8_t wireless_stop;

  PowerBoardState() : ros::Message(),
    serial_num(0),
    input_voltage(0),
    master_state(0),
    run_stop(0),
    wireless_stop(0)
  {
    circuit_state.assign(0);
    circuit_voltage.assign(0);
  }
  PowerBoardState(const PowerBoardState &copy) : ros::Message(),
    header(copy.header),
    name(copy.name),
    serial_num(copy.serial_num),
    input_voltage(copy.input_voltage),
    master_state(copy.master_state),
    run_stop(copy.run_stop),
    wireless_stop(copy.wireless_stop)
  {
    (void)copy;
    circuit_state = copy.circuit_state;
    circuit_voltage = copy.circuit_voltage;
  }
  PowerBoardState &operator =(const PowerBoardState &copy)
  {
    if (this == &copy)
      return *this;
    header = copy.header;
    name = copy.name;
    serial_num = copy.serial_num;
    input_voltage = copy.input_voltage;
    master_state = copy.master_state;
    circuit_state = copy.circuit_state;
    circuit_voltage = copy.circuit_voltage;
    run_stop = copy.run_stop;
    wireless_stop = copy.wireless_stop;
    return *this;
  }
  virtual ~PowerBoardState() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_msgs/PowerBoardState"); }
  inline static std::string __s_getMD5Sum() { return std::string("08899b671e6a1a449e7ce0000da8ae7b"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message communicates the state of the PR2's power board.\n"
    "int8 STATE_NOPOWER=0\n"
    "int8 STATE_STANDBY=1\n"
    "int8 STATE_PUMPING=2\n"
    "int8 STATE_ON=3\n"
    "int8 STATE_ENABLED=3  # Preferred over STATE_ON, keeping STATE_ON for backcompat\n"
    "int8 STATE_DISABLED=4\n"
    "\n"
    "int8 MASTER_NOPOWER=0\n"
    "int8 MASTER_STANDBY=1\n"
    "int8 MASTER_ON=2\n"
    "int8 MASTER_OFF=3\n"
    "int8 MASTER_SHUTDOWN=4\n"
    "\n"
    "Header header\n"
    "string name # Name with serial number\n"
    "uint32 serial_num # Serial number for this board's message\n"
    "float64 input_voltage # Input voltage to power board\n"
    "\n"
    "# Master States:\n"
    "#  MASTER_NOPOWER, MASTER_STANDBY, MASTER_ON, MASTER_OFF, MASTER_SHUTDOWN \n"
    "int8 master_state  # The master state machine's state in the powerboard\n"
    "\n"
    "# Circuit States:\n"
    "#  STATE_NOPOWER, STATE_STANDBY, STATE_PUMPING, STATE_ON, STATE_DISABLED\n"
    "int8[3] circuit_state # One of the above states\n"
    "float64[3] circuit_voltage  # Output voltage of each circuit\n"
    "\n"
    "# True if robot should be enabled\n"
    "bool run_stop           #Note - if the wireless run-stop is hit, this will be unobservable\n"
    "bool wireless_stop \n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t get_circuit_state_size() const { return 3; }
  inline uint32_t get_circuit_voltage_size() const { return 3; }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 0; // STATE_NOPOWER
    __l += 0; // STATE_STANDBY
    __l += 0; // STATE_PUMPING
    __l += 0; // STATE_ON
    __l += 0; // STATE_ENABLED
    __l += 0; // STATE_DISABLED
    __l += 0; // MASTER_NOPOWER
    __l += 0; // MASTER_STANDBY
    __l += 0; // MASTER_ON
    __l += 0; // MASTER_OFF
    __l += 0; // MASTER_SHUTDOWN
    __l += header.serializationLength(); // header
    __l += 4 + name.length(); // name
    __l += 4; // serial_num
    __l += 8; // input_voltage
    __l += 1; // master_state
    __l += 3 * 1; // circuit_state
    __l += 3 * 8; // circuit_voltage
    __l += 1; // run_stop
    __l += 1; // wireless_stop
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_name_len = name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, name.c_str(), __ros_name_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, serial_num);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, input_voltage);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, master_state);
    memcpy(write_ptr, &circuit_state[0], sizeof(int8_t) * 3);
    write_ptr += sizeof(int8_t) * 3;
    memcpy(write_ptr, &circuit_voltage[0], sizeof(double) * 3);
    write_ptr += sizeof(double) * 3;
    SROS_SERIALIZE_PRIMITIVE(write_ptr, run_stop);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, wireless_stop);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_name_len);
    name = std::string((const char *)read_ptr, __ros_name_len);
    read_ptr += __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, serial_num);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, input_voltage);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, master_state);
    memcpy(&circuit_state[0], read_ptr, sizeof(int8_t) * 3);
    read_ptr += sizeof(int8_t) * 3;
    memcpy(&circuit_voltage[0], read_ptr, sizeof(double) * 3);
    read_ptr += sizeof(double) * 3;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, run_stop);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, wireless_stop);
    return read_ptr;
  }
};

typedef boost::shared_ptr<PowerBoardState> PowerBoardStatePtr;
typedef boost::shared_ptr<PowerBoardState const> PowerBoardStateConstPtr;


}

#endif
