/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_common/pr2_msgs/msg/PowerState.msg.  Do not edit! */
#ifndef PR2_MSGS_POWERSTATE_H
#define PR2_MSGS_POWERSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"

namespace pr2_msgs
{

//! \htmlinclude PowerState.msg.html

class PowerState : public ros::Message
{
public:
  typedef boost::shared_ptr<PowerState> Ptr;
  typedef boost::shared_ptr<PowerState const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef double _power_consumption_type;
  typedef ros::Duration _time_remaining_type;
  typedef std::string _prediction_method_type;
  typedef int8_t _relative_capacity_type;
  typedef int8_t _AC_present_type;

  roslib::Header header;
  double power_consumption;
  ros::Duration time_remaining;
  std::string prediction_method;
  int8_t relative_capacity;
  int8_t AC_present;

  PowerState() : ros::Message(),
    power_consumption(0),
    relative_capacity(0),
    AC_present(0)
  {
  }
  PowerState(const PowerState &copy) : ros::Message(),
    header(copy.header),
    power_consumption(copy.power_consumption),
    time_remaining(copy.time_remaining),
    prediction_method(copy.prediction_method),
    relative_capacity(copy.relative_capacity),
    AC_present(copy.AC_present)
  {
    (void)copy;
  }
  PowerState &operator =(const PowerState &copy)
  {
    if (this == &copy)
      return *this;
    header = copy.header;
    power_consumption = copy.power_consumption;
    time_remaining = copy.time_remaining;
    prediction_method = copy.prediction_method;
    relative_capacity = copy.relative_capacity;
    AC_present = copy.AC_present;
    return *this;
  }
  virtual ~PowerState() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_msgs/PowerState"); }
  inline static std::string __s_getMD5Sum() { return std::string("e6fa46a387cad0b7a80959a21587a6c9"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message communicates the state of the PR2's power system.\n"
    "Header header\n"
    "float64 power_consumption ## Watts\n"
    "duration time_remaining ## estimated time to empty or full\n"
    "string prediction_method ## how time_remaining is being calculated\n"
    "int8  relative_capacity ## percent of capacity\n"
    "int8  AC_present ## number of packs detecting AC power, > 0 means plugged in\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 8; // power_consumption
    __l += 8; // time_remaining
    __l += 4 + prediction_method.length(); // prediction_method
    __l += 1; // relative_capacity
    __l += 1; // AC_present
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, power_consumption);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, time_remaining.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, time_remaining.nsec);
    unsigned __ros_prediction_method_len = prediction_method.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_prediction_method_len);
    SROS_SERIALIZE_BUFFER(write_ptr, prediction_method.c_str(), __ros_prediction_method_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, relative_capacity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, AC_present);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, power_consumption);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_remaining.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_remaining.nsec);
    unsigned __ros_prediction_method_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_prediction_method_len);
    prediction_method = std::string((const char *)read_ptr, __ros_prediction_method_len);
    read_ptr += __ros_prediction_method_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, relative_capacity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, AC_present);
    return read_ptr;
  }
};

typedef boost::shared_ptr<PowerState> PowerStatePtr;
typedef boost::shared_ptr<PowerState const> PowerStateConstPtr;


}

#endif
