/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_common/pr2_msgs/msg/PressureState.msg.  Do not edit! */
#ifndef PR2_MSGS_PRESSURESTATE_H
#define PR2_MSGS_PRESSURESTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"

namespace pr2_msgs
{

//! \htmlinclude PressureState.msg.html

class PressureState : public ros::Message
{
public:
  typedef boost::shared_ptr<PressureState> Ptr;
  typedef boost::shared_ptr<PressureState const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<int16_t> _l_finger_tip_type;
  typedef std::vector<int16_t> _r_finger_tip_type;

  roslib::Header header;
  std::vector<int16_t> l_finger_tip;
  std::vector<int16_t> r_finger_tip;

  PressureState() : ros::Message()
  {
  }
  PressureState(const PressureState &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    l_finger_tip = copy.l_finger_tip;
    r_finger_tip = copy.r_finger_tip;
  }
  PressureState &operator =(const PressureState &copy)
  {
    if (this == &copy)
      return *this;
    l_finger_tip.clear();
    r_finger_tip.clear();
    header = copy.header;
    l_finger_tip = copy.l_finger_tip;
    r_finger_tip = copy.r_finger_tip;
    return *this;
  }
  virtual ~PressureState() 
  {
    l_finger_tip.clear();
    r_finger_tip.clear();
  }
  inline static std::string __s_getDataType() { return std::string("pr2_msgs/PressureState"); }
  inline static std::string __s_getMD5Sum() { return std::string("756fb3b75fa8884524fd0789a78eb04b"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "#Output from finger-tip pressure sensors on PR2\n"
    "#Higher number correspond to more pressure, but there is no explicit unit and you will have to calibrate for offset\n"
    "#The numbers reported are the raw values from the I2C hardware\n"
    "\n"
    "Header header\n"
    "int16[] l_finger_tip\n"
    "int16[] r_finger_tip\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_l_finger_tip_size(uint32_t __ros_new_size)
  {
    this->l_finger_tip.resize(__ros_new_size);
  }
  inline uint32_t get_l_finger_tip_size() const { return l_finger_tip.size(); }
  inline void get_l_finger_tip_vec (std::vector<int16_t> &__ros_vec) const
  {
    __ros_vec = this->l_finger_tip;
  }
  inline void set_l_finger_tip_vec(const std::vector<int16_t> &__ros_vec)
  {
    this->l_finger_tip = __ros_vec;
  }
  void set_r_finger_tip_size(uint32_t __ros_new_size)
  {
    this->r_finger_tip.resize(__ros_new_size);
  }
  inline uint32_t get_r_finger_tip_size() const { return r_finger_tip.size(); }
  inline void get_r_finger_tip_vec (std::vector<int16_t> &__ros_vec) const
  {
    __ros_vec = this->r_finger_tip;
  }
  inline void set_r_finger_tip_vec(const std::vector<int16_t> &__ros_vec)
  {
    this->r_finger_tip = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + (l_finger_tip.size() ? l_finger_tip.size() * 2 : 0); // l_finger_tip
    __l += 4 + (r_finger_tip.size() ? r_finger_tip.size() * 2 : 0); // r_finger_tip
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __l_finger_tip_size = l_finger_tip.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __l_finger_tip_size);
    memcpy(write_ptr, &l_finger_tip[0], sizeof(int16_t) * __l_finger_tip_size);
    write_ptr += sizeof(int16_t) * __l_finger_tip_size;
    uint32_t __r_finger_tip_size = r_finger_tip.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __r_finger_tip_size);
    memcpy(write_ptr, &r_finger_tip[0], sizeof(int16_t) * __r_finger_tip_size);
    write_ptr += sizeof(int16_t) * __r_finger_tip_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __l_finger_tip_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __l_finger_tip_size);
    set_l_finger_tip_size(__l_finger_tip_size);
    memcpy(&l_finger_tip[0], read_ptr, sizeof(int16_t) * __l_finger_tip_size);
    read_ptr += sizeof(int16_t) * __l_finger_tip_size;
    uint32_t __r_finger_tip_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __r_finger_tip_size);
    set_r_finger_tip_size(__r_finger_tip_size);
    memcpy(&r_finger_tip[0], read_ptr, sizeof(int16_t) * __r_finger_tip_size);
    read_ptr += sizeof(int16_t) * __r_finger_tip_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<PressureState> PressureStatePtr;
typedef boost::shared_ptr<PressureState const> PressureStateConstPtr;


}

#endif
