# autogenerated by genmsg_py from BatteryServer2.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import roslib.msg
import pr2_msgs.msg

class BatteryServer2(roslib.message.Message):
  _md5sum = "5f2cec7d06c312d756189db96c1f3819"
  _type = "pr2_msgs/BatteryServer2"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message communicates the state of a battery server, which controls
# multiple batteries.
Header header
int32 MAX_BAT_COUNT=4
int32 MAX_BAT_REG=48
int32 id  # unique ID for each battery server
# Battery System Stats
time last_system_update  # last time the system stats where updated
duration time_left       # in seconds (hardware resolution is 1 minute)
int32 average_charge     # in percent
string message           # message from the ocean server
time last_controller_update # last time a battery status flag was updated
# for each battery
pr2_msgs/BatteryState2[] battery

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: pr2_msgs/BatteryState2
# This message communicates the state of a single battery.
# Battery Controller Flags, one per battery
bool present       # is this pack present
bool charging      # is this pack charging
bool discharging   # is this pack discharging
bool power_present # is there an input voltage
bool power_no_good # is there a fault (No Good)
bool inhibited     # is this pack disabled for some reason
# These registers are per battery
time      last_battery_update     # last time any battery update occurred
int16[48] battery_register        # value of this register in the battery
bool[48]  battery_update_flag     # Has this register ever been updated
time[48]  battery_register_update # last time this specific register was updated

"""
  # Pseudo-constants
  MAX_BAT_COUNT = 4
  MAX_BAT_REG = 48

  __slots__ = ['header','id','last_system_update','time_left','average_charge','message','last_controller_update','battery']
  _slot_types = ['Header','int32','time','duration','int32','string','time','pr2_msgs/BatteryState2[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,id,last_system_update,time_left,average_charge,message,last_controller_update,battery
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(BatteryServer2, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.id is None:
        self.id = 0
      if self.last_system_update is None:
        self.last_system_update = roslib.rostime.Time()
      if self.time_left is None:
        self.time_left = roslib.rostime.Duration()
      if self.average_charge is None:
        self.average_charge = 0
      if self.message is None:
        self.message = ''
      if self.last_controller_update is None:
        self.last_controller_update = roslib.rostime.Time()
      if self.battery is None:
        self.battery = []
    else:
      self.header = roslib.msg._Header.Header()
      self.id = 0
      self.last_system_update = roslib.rostime.Time()
      self.time_left = roslib.rostime.Duration()
      self.average_charge = 0
      self.message = ''
      self.last_controller_update = roslib.rostime.Time()
      self.battery = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<i2I3i', self.id, self.last_system_update.secs, self.last_system_update.nsecs, self.time_left.secs, self.time_left.nsecs, self.average_charge))
      length = len(self.message)
      #serialize self.message
      buff.write(struct.pack('<I%ss'%length, length, self.message))
      buff.write(struct.pack('<2I', self.last_controller_update.secs, self.last_controller_update.nsecs))
      #serialize self.battery
      length = len(self.battery)
      buff.write(struct.pack('<I', length))
      for val1 in self.battery:
        buff.write(struct.pack('<6B', val1.present, val1.charging, val1.discharging, val1.power_present, val1.power_no_good, val1.inhibited))
        buff.write(struct.pack('<2I', val1.last_battery_update.secs, val1.last_battery_update.nsecs))
        #serialize val1.battery_register
        buff.write(struct.pack('<48h', *val1.battery_register))
        #serialize val1.battery_update_flag
        buff.write(struct.pack('<48B', *val1.battery_update_flag))
        #serialize val1.battery_register_update
        for val2 in val1.battery_register_update:
          buff.write(struct.pack('<2I', val2.secs, val2.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.last_system_update is None:
        self.last_system_update = roslib.rostime.Time()
      if self.time_left is None:
        self.time_left = roslib.rostime.Duration()
      if self.last_controller_update is None:
        self.last_controller_update = roslib.rostime.Time()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 24
      (self.id, self.last_system_update.secs, self.last_system_update.nsecs, self.time_left.secs, self.time_left.nsecs, self.average_charge,) = struct.unpack('<i2I3i',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.message,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.last_controller_update.secs, self.last_controller_update.nsecs,) = struct.unpack('<2I',str[start:end])
      #deserialize self.battery
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.battery = []
      for i in xrange(0, length):
        val1 = pr2_msgs.msg.BatteryState2()
        start = end
        end += 6
        (val1.present, val1.charging, val1.discharging, val1.power_present, val1.power_no_good, val1.inhibited,) = struct.unpack('<6B',str[start:end])
        val1.present = bool(val1.present)
        val1.charging = bool(val1.charging)
        val1.discharging = bool(val1.discharging)
        val1.power_present = bool(val1.power_present)
        val1.power_no_good = bool(val1.power_no_good)
        val1.inhibited = bool(val1.inhibited)
        start = end
        end += 8
        (val1.last_battery_update.secs, val1.last_battery_update.nsecs,) = struct.unpack('<2I',str[start:end])
        #deserialize val1.battery_register
        start = end
        end += 96
        val1.battery_register = struct.unpack('<48h',str[start:end])
        #deserialize val1.battery_update_flag
        start = end
        end += 48
        val1.battery_update_flag = struct.unpack('<48B',str[start:end])
        val1.battery_update_flag = map(bool, val1.battery_update_flag)
        #deserialize val1.battery_register_update
        val1.battery_register_update = []
        for i in xrange(0, 48):
          val2 = roslib.rostime.Time()
          start = end
          end += 8
          (val2.secs, val2.nsecs,) = struct.unpack('<2I',str[start:end])
          val1.battery_register_update.append(val2)
        self.battery.append(val1)
      self.last_system_update.canon()
      self.time_left.canon()
      self.last_controller_update.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<i2I3i', self.id, self.last_system_update.secs, self.last_system_update.nsecs, self.time_left.secs, self.time_left.nsecs, self.average_charge))
      length = len(self.message)
      #serialize self.message
      buff.write(struct.pack('<I%ss'%length, length, self.message))
      buff.write(struct.pack('<2I', self.last_controller_update.secs, self.last_controller_update.nsecs))
      #serialize self.battery
      length = len(self.battery)
      buff.write(struct.pack('<I', length))
      for val1 in self.battery:
        buff.write(struct.pack('<6B', val1.present, val1.charging, val1.discharging, val1.power_present, val1.power_no_good, val1.inhibited))
        buff.write(struct.pack('<2I', val1.last_battery_update.secs, val1.last_battery_update.nsecs))
        #serialize val1.battery_register
        buff.write(val1.battery_register.tostring())
        #serialize val1.battery_update_flag
        buff.write(val1.battery_update_flag.tostring())
        #serialize val1.battery_register_update
        for val2 in val1.battery_register_update:
          buff.write(struct.pack('<2I', val2.secs, val2.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.last_system_update is None:
        self.last_system_update = roslib.rostime.Time()
      if self.time_left is None:
        self.time_left = roslib.rostime.Duration()
      if self.last_controller_update is None:
        self.last_controller_update = roslib.rostime.Time()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 24
      (self.id, self.last_system_update.secs, self.last_system_update.nsecs, self.time_left.secs, self.time_left.nsecs, self.average_charge,) = struct.unpack('<i2I3i',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.message,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.last_controller_update.secs, self.last_controller_update.nsecs,) = struct.unpack('<2I',str[start:end])
      #deserialize self.battery
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.battery = []
      for i in xrange(0, length):
        val1 = pr2_msgs.msg.BatteryState2()
        start = end
        end += 6
        (val1.present, val1.charging, val1.discharging, val1.power_present, val1.power_no_good, val1.inhibited,) = struct.unpack('<6B',str[start:end])
        val1.present = bool(val1.present)
        val1.charging = bool(val1.charging)
        val1.discharging = bool(val1.discharging)
        val1.power_present = bool(val1.power_present)
        val1.power_no_good = bool(val1.power_no_good)
        val1.inhibited = bool(val1.inhibited)
        start = end
        end += 8
        (val1.last_battery_update.secs, val1.last_battery_update.nsecs,) = struct.unpack('<2I',str[start:end])
        #deserialize val1.battery_register
        start = end
        end += 96
        val1.battery_register = numpy.frombuffer(str[start:end], dtype=numpy.int16, count=48)
        #deserialize val1.battery_update_flag
        start = end
        end += 48
        val1.battery_update_flag = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=48)
        val1.battery_update_flag = map(bool, val1.battery_update_flag)
        #deserialize val1.battery_register_update
        val1.battery_register_update = []
        for i in xrange(0, 48):
          val2 = roslib.rostime.Time()
          start = end
          end += 8
          (val2.secs, val2.nsecs,) = struct.unpack('<2I',str[start:end])
          val1.battery_register_update.append(val2)
        self.battery.append(val1)
      self.last_system_update.canon()
      self.time_left.canon()
      self.last_controller_update.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

