# autogenerated by genmsg_py from DashboardState.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import roslib.msg
import pr2_msgs.msg
import std_msgs.msg

class DashboardState(roslib.message.Message):
  _md5sum = "db0cd0d535d75e0f6257b20c403e87f5"
  _type = "pr2_msgs/DashboardState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This message communicates state information that might be used by a
# dashboard application.
std_msgs/Bool motors_halted
bool motors_halted_valid

pr2_msgs/PowerBoardState power_board_state
bool power_board_state_valid

pr2_msgs/PowerState power_state
bool power_state_valid

pr2_msgs/AccessPoint access_point
bool access_point_valid

================================================================================
MSG: std_msgs/Bool
bool data
================================================================================
MSG: pr2_msgs/PowerBoardState
# This message communicates the state of the PR2's power board.
int8 STATE_NOPOWER=0
int8 STATE_STANDBY=1
int8 STATE_PUMPING=2
int8 STATE_ON=3
int8 STATE_ENABLED=3  # Preferred over STATE_ON, keeping STATE_ON for backcompat
int8 STATE_DISABLED=4

int8 MASTER_NOPOWER=0
int8 MASTER_STANDBY=1
int8 MASTER_ON=2
int8 MASTER_OFF=3
int8 MASTER_SHUTDOWN=4

Header header
string name # Name with serial number
uint32 serial_num # Serial number for this board's message
float64 input_voltage # Input voltage to power board

# Master States:
#  MASTER_NOPOWER, MASTER_STANDBY, MASTER_ON, MASTER_OFF, MASTER_SHUTDOWN 
int8 master_state  # The master state machine's state in the powerboard

# Circuit States:
#  STATE_NOPOWER, STATE_STANDBY, STATE_PUMPING, STATE_ON, STATE_DISABLED
int8[3] circuit_state # One of the above states
float64[3] circuit_voltage  # Output voltage of each circuit

# True if robot should be enabled
bool run_stop           #Note - if the wireless run-stop is hit, this will be unobservable
bool wireless_stop 

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: pr2_msgs/PowerState
# This message communicates the state of the PR2's power system.
Header header
float64 power_consumption ## Watts
duration time_remaining ## estimated time to empty or full
string prediction_method ## how time_remaining is being calculated
int8  relative_capacity ## percent of capacity
int8  AC_present ## number of packs detecting AC power, > 0 means plugged in

================================================================================
MSG: pr2_msgs/AccessPoint
# This message communicates the state of the PR2's wifi access point.
Header header
string essid
string macaddr
int32 signal
int32 noise
int32 snr
int32 channel
string rate
string tx_power
int32 quality

"""
  __slots__ = ['motors_halted','motors_halted_valid','power_board_state','power_board_state_valid','power_state','power_state_valid','access_point','access_point_valid']
  _slot_types = ['std_msgs/Bool','bool','pr2_msgs/PowerBoardState','bool','pr2_msgs/PowerState','bool','pr2_msgs/AccessPoint','bool']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   motors_halted,motors_halted_valid,power_board_state,power_board_state_valid,power_state,power_state_valid,access_point,access_point_valid
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(DashboardState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.motors_halted is None:
        self.motors_halted = std_msgs.msg.Bool()
      if self.motors_halted_valid is None:
        self.motors_halted_valid = False
      if self.power_board_state is None:
        self.power_board_state = pr2_msgs.msg.PowerBoardState()
      if self.power_board_state_valid is None:
        self.power_board_state_valid = False
      if self.power_state is None:
        self.power_state = pr2_msgs.msg.PowerState()
      if self.power_state_valid is None:
        self.power_state_valid = False
      if self.access_point is None:
        self.access_point = pr2_msgs.msg.AccessPoint()
      if self.access_point_valid is None:
        self.access_point_valid = False
    else:
      self.motors_halted = std_msgs.msg.Bool()
      self.motors_halted_valid = False
      self.power_board_state = pr2_msgs.msg.PowerBoardState()
      self.power_board_state_valid = False
      self.power_state = pr2_msgs.msg.PowerState()
      self.power_state_valid = False
      self.access_point = pr2_msgs.msg.AccessPoint()
      self.access_point_valid = False

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<2B3I', self.motors_halted.data, self.motors_halted_valid, self.power_board_state.header.seq, self.power_board_state.header.stamp.secs, self.power_board_state.header.stamp.nsecs))
      length = len(self.power_board_state.header.frame_id)
      #serialize self.power_board_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.power_board_state.header.frame_id))
      length = len(self.power_board_state.name)
      #serialize self.power_board_state.name
      buff.write(struct.pack('<I%ss'%length, length, self.power_board_state.name))
      buff.write(struct.pack('<Idb', self.power_board_state.serial_num, self.power_board_state.input_voltage, self.power_board_state.master_state))
      #serialize self.power_board_state.circuit_state
      buff.write(struct.pack('<3b', *self.power_board_state.circuit_state))
      #serialize self.power_board_state.circuit_voltage
      buff.write(struct.pack('<3d', *self.power_board_state.circuit_voltage))
      buff.write(struct.pack('<3B3I', self.power_board_state.run_stop, self.power_board_state.wireless_stop, self.power_board_state_valid, self.power_state.header.seq, self.power_state.header.stamp.secs, self.power_state.header.stamp.nsecs))
      length = len(self.power_state.header.frame_id)
      #serialize self.power_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.power_state.header.frame_id))
      buff.write(struct.pack('<d2i', self.power_state.power_consumption, self.power_state.time_remaining.secs, self.power_state.time_remaining.nsecs))
      length = len(self.power_state.prediction_method)
      #serialize self.power_state.prediction_method
      buff.write(struct.pack('<I%ss'%length, length, self.power_state.prediction_method))
      buff.write(struct.pack('<2bB3I', self.power_state.relative_capacity, self.power_state.AC_present, self.power_state_valid, self.access_point.header.seq, self.access_point.header.stamp.secs, self.access_point.header.stamp.nsecs))
      length = len(self.access_point.header.frame_id)
      #serialize self.access_point.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.header.frame_id))
      length = len(self.access_point.essid)
      #serialize self.access_point.essid
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.essid))
      length = len(self.access_point.macaddr)
      #serialize self.access_point.macaddr
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.macaddr))
      buff.write(struct.pack('<4i', self.access_point.signal, self.access_point.noise, self.access_point.snr, self.access_point.channel))
      length = len(self.access_point.rate)
      #serialize self.access_point.rate
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.rate))
      length = len(self.access_point.tx_power)
      #serialize self.access_point.tx_power
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.tx_power))
      buff.write(struct.pack('<iB', self.access_point.quality, self.access_point_valid))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.motors_halted is None:
        self.motors_halted = std_msgs.msg.Bool()
      if self.power_board_state is None:
        self.power_board_state = pr2_msgs.msg.PowerBoardState()
      if self.power_state is None:
        self.power_state = pr2_msgs.msg.PowerState()
      if self.access_point is None:
        self.access_point = pr2_msgs.msg.AccessPoint()
      end = 0
      start = end
      end += 14
      (self.motors_halted.data, self.motors_halted_valid, self.power_board_state.header.seq, self.power_board_state.header.stamp.secs, self.power_board_state.header.stamp.nsecs,) = struct.unpack('<2B3I',str[start:end])
      self.motors_halted.data = bool(self.motors_halted.data)
      self.motors_halted_valid = bool(self.motors_halted_valid)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.power_board_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.power_board_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.power_board_state.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.power_board_state.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 13
      (self.power_board_state.serial_num, self.power_board_state.input_voltage, self.power_board_state.master_state,) = struct.unpack('<Idb',str[start:end])
      #deserialize self.power_board_state.circuit_state
      start = end
      end += 3
      self.power_board_state.circuit_state = struct.unpack('<3b',str[start:end])
      #deserialize self.power_board_state.circuit_voltage
      start = end
      end += 24
      self.power_board_state.circuit_voltage = struct.unpack('<3d',str[start:end])
      start = end
      end += 15
      (self.power_board_state.run_stop, self.power_board_state.wireless_stop, self.power_board_state_valid, self.power_state.header.seq, self.power_state.header.stamp.secs, self.power_state.header.stamp.nsecs,) = struct.unpack('<3B3I',str[start:end])
      self.power_board_state.run_stop = bool(self.power_board_state.run_stop)
      self.power_board_state.wireless_stop = bool(self.power_board_state.wireless_stop)
      self.power_board_state_valid = bool(self.power_board_state_valid)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.power_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.power_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.power_state.power_consumption, self.power_state.time_remaining.secs, self.power_state.time_remaining.nsecs,) = struct.unpack('<d2i',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.power_state.prediction_method
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.power_state.prediction_method,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 15
      (self.power_state.relative_capacity, self.power_state.AC_present, self.power_state_valid, self.access_point.header.seq, self.access_point.header.stamp.secs, self.access_point.header.stamp.nsecs,) = struct.unpack('<2bB3I',str[start:end])
      self.power_state_valid = bool(self.power_state_valid)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.essid
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.essid,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.macaddr
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.macaddr,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.access_point.signal, self.access_point.noise, self.access_point.snr, self.access_point.channel,) = struct.unpack('<4i',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.rate
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.rate,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.tx_power
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.tx_power,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.access_point.quality, self.access_point_valid,) = struct.unpack('<iB',str[start:end])
      self.access_point_valid = bool(self.access_point_valid)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<2B3I', self.motors_halted.data, self.motors_halted_valid, self.power_board_state.header.seq, self.power_board_state.header.stamp.secs, self.power_board_state.header.stamp.nsecs))
      length = len(self.power_board_state.header.frame_id)
      #serialize self.power_board_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.power_board_state.header.frame_id))
      length = len(self.power_board_state.name)
      #serialize self.power_board_state.name
      buff.write(struct.pack('<I%ss'%length, length, self.power_board_state.name))
      buff.write(struct.pack('<Idb', self.power_board_state.serial_num, self.power_board_state.input_voltage, self.power_board_state.master_state))
      #serialize self.power_board_state.circuit_state
      buff.write(self.power_board_state.circuit_state.tostring())
      #serialize self.power_board_state.circuit_voltage
      buff.write(self.power_board_state.circuit_voltage.tostring())
      buff.write(struct.pack('<3B3I', self.power_board_state.run_stop, self.power_board_state.wireless_stop, self.power_board_state_valid, self.power_state.header.seq, self.power_state.header.stamp.secs, self.power_state.header.stamp.nsecs))
      length = len(self.power_state.header.frame_id)
      #serialize self.power_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.power_state.header.frame_id))
      buff.write(struct.pack('<d2i', self.power_state.power_consumption, self.power_state.time_remaining.secs, self.power_state.time_remaining.nsecs))
      length = len(self.power_state.prediction_method)
      #serialize self.power_state.prediction_method
      buff.write(struct.pack('<I%ss'%length, length, self.power_state.prediction_method))
      buff.write(struct.pack('<2bB3I', self.power_state.relative_capacity, self.power_state.AC_present, self.power_state_valid, self.access_point.header.seq, self.access_point.header.stamp.secs, self.access_point.header.stamp.nsecs))
      length = len(self.access_point.header.frame_id)
      #serialize self.access_point.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.header.frame_id))
      length = len(self.access_point.essid)
      #serialize self.access_point.essid
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.essid))
      length = len(self.access_point.macaddr)
      #serialize self.access_point.macaddr
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.macaddr))
      buff.write(struct.pack('<4i', self.access_point.signal, self.access_point.noise, self.access_point.snr, self.access_point.channel))
      length = len(self.access_point.rate)
      #serialize self.access_point.rate
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.rate))
      length = len(self.access_point.tx_power)
      #serialize self.access_point.tx_power
      buff.write(struct.pack('<I%ss'%length, length, self.access_point.tx_power))
      buff.write(struct.pack('<iB', self.access_point.quality, self.access_point_valid))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.motors_halted is None:
        self.motors_halted = std_msgs.msg.Bool()
      if self.power_board_state is None:
        self.power_board_state = pr2_msgs.msg.PowerBoardState()
      if self.power_state is None:
        self.power_state = pr2_msgs.msg.PowerState()
      if self.access_point is None:
        self.access_point = pr2_msgs.msg.AccessPoint()
      end = 0
      start = end
      end += 14
      (self.motors_halted.data, self.motors_halted_valid, self.power_board_state.header.seq, self.power_board_state.header.stamp.secs, self.power_board_state.header.stamp.nsecs,) = struct.unpack('<2B3I',str[start:end])
      self.motors_halted.data = bool(self.motors_halted.data)
      self.motors_halted_valid = bool(self.motors_halted_valid)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.power_board_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.power_board_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.power_board_state.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.power_board_state.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 13
      (self.power_board_state.serial_num, self.power_board_state.input_voltage, self.power_board_state.master_state,) = struct.unpack('<Idb',str[start:end])
      #deserialize self.power_board_state.circuit_state
      start = end
      end += 3
      self.power_board_state.circuit_state = numpy.frombuffer(str[start:end], dtype=numpy.int8, count=3)
      #deserialize self.power_board_state.circuit_voltage
      start = end
      end += 24
      self.power_board_state.circuit_voltage = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 15
      (self.power_board_state.run_stop, self.power_board_state.wireless_stop, self.power_board_state_valid, self.power_state.header.seq, self.power_state.header.stamp.secs, self.power_state.header.stamp.nsecs,) = struct.unpack('<3B3I',str[start:end])
      self.power_board_state.run_stop = bool(self.power_board_state.run_stop)
      self.power_board_state.wireless_stop = bool(self.power_board_state.wireless_stop)
      self.power_board_state_valid = bool(self.power_board_state_valid)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.power_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.power_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.power_state.power_consumption, self.power_state.time_remaining.secs, self.power_state.time_remaining.nsecs,) = struct.unpack('<d2i',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.power_state.prediction_method
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.power_state.prediction_method,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 15
      (self.power_state.relative_capacity, self.power_state.AC_present, self.power_state_valid, self.access_point.header.seq, self.access_point.header.stamp.secs, self.access_point.header.stamp.nsecs,) = struct.unpack('<2bB3I',str[start:end])
      self.power_state_valid = bool(self.power_state_valid)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.essid
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.essid,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.macaddr
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.macaddr,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.access_point.signal, self.access_point.noise, self.access_point.snr, self.access_point.channel,) = struct.unpack('<4i',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.rate
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.rate,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.access_point.tx_power
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.access_point.tx_power,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.access_point.quality, self.access_point_valid,) = struct.unpack('<iB',str[start:end])
      self.access_point_valid = bool(self.access_point_valid)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

