# autogenerated by genmsg_py from LaserTrajCmd.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import roslib.msg

class LaserTrajCmd(roslib.message.Message):
  _md5sum = "68a1665e9079049dce55a0384cb2e9b5"
  _type = "pr2_msgs/LaserTrajCmd"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message is used to set the profile that the tilt laser controller
# executes.
Header header
string profile              # options are currently "linear" or "linear_blended"
float64[] position          # Laser positions
duration[] time_from_start  # Times to reach laser positions in seconds
float64 max_velocity        # Set <= 0 to use default
float64 max_acceleration    # Set <= 0 to use default

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','profile','position','time_from_start','max_velocity','max_acceleration']
  _slot_types = ['Header','string','float64[]','duration[]','float64','float64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,profile,position,time_from_start,max_velocity,max_acceleration
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(LaserTrajCmd, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.profile is None:
        self.profile = ''
      if self.position is None:
        self.position = []
      if self.time_from_start is None:
        self.time_from_start = []
      if self.max_velocity is None:
        self.max_velocity = 0.
      if self.max_acceleration is None:
        self.max_acceleration = 0.
    else:
      self.header = roslib.msg._Header.Header()
      self.profile = ''
      self.position = []
      self.time_from_start = []
      self.max_velocity = 0.
      self.max_acceleration = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.profile)
      #serialize self.profile
      buff.write(struct.pack('<I%ss'%length, length, self.profile))
      #serialize self.position
      length = len(self.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.position))
      #serialize self.time_from_start
      length = len(self.time_from_start)
      buff.write(struct.pack('<I', length))
      for val1 in self.time_from_start:
        buff.write(struct.pack('<2i', val1.secs, val1.nsecs))
      buff.write(struct.pack('<2d', self.max_velocity, self.max_acceleration))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.profile
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.profile,) = struct.unpack(pattern, str[start:end])
      #deserialize self.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.position = struct.unpack(pattern, str[start:end])
      #deserialize self.time_from_start
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.time_from_start = []
      for i in xrange(0, length):
        val1 = roslib.rostime.Duration()
        start = end
        end += 8
        (val1.secs, val1.nsecs,) = struct.unpack('<2i',str[start:end])
        self.time_from_start.append(val1)
      start = end
      end += 16
      (self.max_velocity, self.max_acceleration,) = struct.unpack('<2d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.profile)
      #serialize self.profile
      buff.write(struct.pack('<I%ss'%length, length, self.profile))
      #serialize self.position
      length = len(self.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.position.tostring())
      #serialize self.time_from_start
      length = len(self.time_from_start)
      buff.write(struct.pack('<I', length))
      for val1 in self.time_from_start:
        buff.write(struct.pack('<2i', val1.secs, val1.nsecs))
      buff.write(struct.pack('<2d', self.max_velocity, self.max_acceleration))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.profile
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.profile,) = struct.unpack(pattern, str[start:end])
      #deserialize self.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.time_from_start
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.time_from_start = []
      for i in xrange(0, length):
        val1 = roslib.rostime.Duration()
        start = end
        end += 8
        (val1.secs, val1.nsecs,) = struct.unpack('<2i',str[start:end])
        self.time_from_start.append(val1)
      start = end
      end += 16
      (self.max_velocity, self.max_acceleration,) = struct.unpack('<2d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

