# autogenerated by genmsg_py from PowerBoardState.msg. Do not edit.
import roslib.message
import struct

import roslib.msg

class PowerBoardState(roslib.message.Message):
  _md5sum = "08899b671e6a1a449e7ce0000da8ae7b"
  _type = "pr2_msgs/PowerBoardState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message communicates the state of the PR2's power board.
int8 STATE_NOPOWER=0
int8 STATE_STANDBY=1
int8 STATE_PUMPING=2
int8 STATE_ON=3
int8 STATE_ENABLED=3  # Preferred over STATE_ON, keeping STATE_ON for backcompat
int8 STATE_DISABLED=4

int8 MASTER_NOPOWER=0
int8 MASTER_STANDBY=1
int8 MASTER_ON=2
int8 MASTER_OFF=3
int8 MASTER_SHUTDOWN=4

Header header
string name # Name with serial number
uint32 serial_num # Serial number for this board's message
float64 input_voltage # Input voltage to power board

# Master States:
#  MASTER_NOPOWER, MASTER_STANDBY, MASTER_ON, MASTER_OFF, MASTER_SHUTDOWN 
int8 master_state  # The master state machine's state in the powerboard

# Circuit States:
#  STATE_NOPOWER, STATE_STANDBY, STATE_PUMPING, STATE_ON, STATE_DISABLED
int8[3] circuit_state # One of the above states
float64[3] circuit_voltage  # Output voltage of each circuit

# True if robot should be enabled
bool run_stop           #Note - if the wireless run-stop is hit, this will be unobservable
bool wireless_stop 

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  # Pseudo-constants
  STATE_NOPOWER = 0
  STATE_STANDBY = 1
  STATE_PUMPING = 2
  STATE_ON = 3
  STATE_ENABLED = 3
  STATE_DISABLED = 4
  MASTER_NOPOWER = 0
  MASTER_STANDBY = 1
  MASTER_ON = 2
  MASTER_OFF = 3
  MASTER_SHUTDOWN = 4

  __slots__ = ['header','name','serial_num','input_voltage','master_state','circuit_state','circuit_voltage','run_stop','wireless_stop']
  _slot_types = ['Header','string','uint32','float64','int8','int8[3]','float64[3]','bool','bool']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,name,serial_num,input_voltage,master_state,circuit_state,circuit_voltage,run_stop,wireless_stop
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(PowerBoardState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.name is None:
        self.name = ''
      if self.serial_num is None:
        self.serial_num = 0
      if self.input_voltage is None:
        self.input_voltage = 0.
      if self.master_state is None:
        self.master_state = 0
      if self.circuit_state is None:
        self.circuit_state = [0,0,0]
      if self.circuit_voltage is None:
        self.circuit_voltage = [0.,0.,0.]
      if self.run_stop is None:
        self.run_stop = False
      if self.wireless_stop is None:
        self.wireless_stop = False
    else:
      self.header = roslib.msg._Header.Header()
      self.name = ''
      self.serial_num = 0
      self.input_voltage = 0.
      self.master_state = 0
      self.circuit_state = [0,0,0]
      self.circuit_voltage = [0.,0.,0.]
      self.run_stop = False
      self.wireless_stop = False

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<Idb', self.serial_num, self.input_voltage, self.master_state))
      #serialize self.circuit_state
      buff.write(struct.pack('<3b', *self.circuit_state))
      #serialize self.circuit_voltage
      buff.write(struct.pack('<3d', *self.circuit_voltage))
      buff.write(struct.pack('<2B', self.run_stop, self.wireless_stop))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 13
      (self.serial_num, self.input_voltage, self.master_state,) = struct.unpack('<Idb',str[start:end])
      #deserialize self.circuit_state
      start = end
      end += 3
      self.circuit_state = struct.unpack('<3b',str[start:end])
      #deserialize self.circuit_voltage
      start = end
      end += 24
      self.circuit_voltage = struct.unpack('<3d',str[start:end])
      start = end
      end += 2
      (self.run_stop, self.wireless_stop,) = struct.unpack('<2B',str[start:end])
      self.run_stop = bool(self.run_stop)
      self.wireless_stop = bool(self.wireless_stop)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<Idb', self.serial_num, self.input_voltage, self.master_state))
      #serialize self.circuit_state
      buff.write(self.circuit_state.tostring())
      #serialize self.circuit_voltage
      buff.write(self.circuit_voltage.tostring())
      buff.write(struct.pack('<2B', self.run_stop, self.wireless_stop))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 13
      (self.serial_num, self.input_voltage, self.master_state,) = struct.unpack('<Idb',str[start:end])
      #deserialize self.circuit_state
      start = end
      end += 3
      self.circuit_state = numpy.frombuffer(str[start:end], dtype=numpy.int8, count=3)
      #deserialize self.circuit_voltage
      start = end
      end += 24
      self.circuit_voltage = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 2
      (self.run_stop, self.wireless_stop,) = struct.unpack('<2B',str[start:end])
      self.run_stop = bool(self.run_stop)
      self.wireless_stop = bool(self.wireless_stop)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

