# autogenerated by genmsg_py from PowerState.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import roslib.msg

class PowerState(roslib.message.Message):
  _md5sum = "e6fa46a387cad0b7a80959a21587a6c9"
  _type = "pr2_msgs/PowerState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message communicates the state of the PR2's power system.
Header header
float64 power_consumption ## Watts
duration time_remaining ## estimated time to empty or full
string prediction_method ## how time_remaining is being calculated
int8  relative_capacity ## percent of capacity
int8  AC_present ## number of packs detecting AC power, > 0 means plugged in

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','power_consumption','time_remaining','prediction_method','relative_capacity','AC_present']
  _slot_types = ['Header','float64','duration','string','int8','int8']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,power_consumption,time_remaining,prediction_method,relative_capacity,AC_present
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(PowerState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.power_consumption is None:
        self.power_consumption = 0.
      if self.time_remaining is None:
        self.time_remaining = roslib.rostime.Duration()
      if self.prediction_method is None:
        self.prediction_method = ''
      if self.relative_capacity is None:
        self.relative_capacity = 0
      if self.AC_present is None:
        self.AC_present = 0
    else:
      self.header = roslib.msg._Header.Header()
      self.power_consumption = 0.
      self.time_remaining = roslib.rostime.Duration()
      self.prediction_method = ''
      self.relative_capacity = 0
      self.AC_present = 0

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<d2i', self.power_consumption, self.time_remaining.secs, self.time_remaining.nsecs))
      length = len(self.prediction_method)
      #serialize self.prediction_method
      buff.write(struct.pack('<I%ss'%length, length, self.prediction_method))
      buff.write(struct.pack('<2b', self.relative_capacity, self.AC_present))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.time_remaining is None:
        self.time_remaining = roslib.rostime.Duration()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.power_consumption, self.time_remaining.secs, self.time_remaining.nsecs,) = struct.unpack('<d2i',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.prediction_method
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.prediction_method,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 2
      (self.relative_capacity, self.AC_present,) = struct.unpack('<2b',str[start:end])
      self.time_remaining.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<d2i', self.power_consumption, self.time_remaining.secs, self.time_remaining.nsecs))
      length = len(self.prediction_method)
      #serialize self.prediction_method
      buff.write(struct.pack('<I%ss'%length, length, self.prediction_method))
      buff.write(struct.pack('<2b', self.relative_capacity, self.AC_present))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.time_remaining is None:
        self.time_remaining = roslib.rostime.Duration()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.power_consumption, self.time_remaining.secs, self.time_remaining.nsecs,) = struct.unpack('<d2i',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.prediction_method
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.prediction_method,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 2
      (self.relative_capacity, self.AC_present,) = struct.unpack('<2b',str[start:end])
      self.time_remaining.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

