# autogenerated by genmsg_py from PressureState.msg. Do not edit.
import roslib.message
import struct

import roslib.msg

class PressureState(roslib.message.Message):
  _md5sum = "756fb3b75fa8884524fd0789a78eb04b"
  _type = "pr2_msgs/PressureState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """#Output from finger-tip pressure sensors on PR2
#Higher number correspond to more pressure, but there is no explicit unit and you will have to calibrate for offset
#The numbers reported are the raw values from the I2C hardware

Header header
int16[] l_finger_tip
int16[] r_finger_tip

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','l_finger_tip','r_finger_tip']
  _slot_types = ['Header','int16[]','int16[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,l_finger_tip,r_finger_tip
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(PressureState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.l_finger_tip is None:
        self.l_finger_tip = []
      if self.r_finger_tip is None:
        self.r_finger_tip = []
    else:
      self.header = roslib.msg._Header.Header()
      self.l_finger_tip = []
      self.r_finger_tip = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.l_finger_tip
      length = len(self.l_finger_tip)
      buff.write(struct.pack('<I', length))
      pattern = '<%sh'%length
      buff.write(struct.pack(pattern, *self.l_finger_tip))
      #serialize self.r_finger_tip
      length = len(self.r_finger_tip)
      buff.write(struct.pack('<I', length))
      pattern = '<%sh'%length
      buff.write(struct.pack(pattern, *self.r_finger_tip))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.l_finger_tip
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sh'%length
      start = end
      end += struct.calcsize(pattern)
      self.l_finger_tip = struct.unpack(pattern, str[start:end])
      #deserialize self.r_finger_tip
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sh'%length
      start = end
      end += struct.calcsize(pattern)
      self.r_finger_tip = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.l_finger_tip
      length = len(self.l_finger_tip)
      buff.write(struct.pack('<I', length))
      pattern = '<%sh'%length
      buff.write(self.l_finger_tip.tostring())
      #serialize self.r_finger_tip
      length = len(self.r_finger_tip)
      buff.write(struct.pack('<I', length))
      pattern = '<%sh'%length
      buff.write(self.r_finger_tip.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.l_finger_tip
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sh'%length
      start = end
      end += struct.calcsize(pattern)
      self.l_finger_tip = numpy.frombuffer(str[start:end], dtype=numpy.int16, count=length)
      #deserialize self.r_finger_tip
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sh'%length
      start = end
      end += struct.calcsize(pattern)
      self.r_finger_tip = numpy.frombuffer(str[start:end], dtype=numpy.int16, count=length)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

