# autogenerated by genmsg_py from SetLaserTrajCmdRequest.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import roslib.msg
import pr2_msgs.msg

class SetLaserTrajCmdRequest(roslib.message.Message):
  _md5sum = "83f915c37d36f61442c752779261e7d4"
  _type = "pr2_msgs/SetLaserTrajCmdRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """pr2_msgs/LaserTrajCmd command

================================================================================
MSG: pr2_msgs/LaserTrajCmd
# This message is used to set the profile that the tilt laser controller
# executes.
Header header
string profile              # options are currently "linear" or "linear_blended"
float64[] position          # Laser positions
duration[] time_from_start  # Times to reach laser positions in seconds
float64 max_velocity        # Set <= 0 to use default
float64 max_acceleration    # Set <= 0 to use default

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['command']
  _slot_types = ['pr2_msgs/LaserTrajCmd']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   command
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetLaserTrajCmdRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.command is None:
        self.command = pr2_msgs.msg.LaserTrajCmd()
    else:
      self.command = pr2_msgs.msg.LaserTrajCmd()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.command.header.seq, self.command.header.stamp.secs, self.command.header.stamp.nsecs))
      length = len(self.command.header.frame_id)
      #serialize self.command.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.command.header.frame_id))
      length = len(self.command.profile)
      #serialize self.command.profile
      buff.write(struct.pack('<I%ss'%length, length, self.command.profile))
      #serialize self.command.position
      length = len(self.command.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.command.position))
      #serialize self.command.time_from_start
      length = len(self.command.time_from_start)
      buff.write(struct.pack('<I', length))
      for val1 in self.command.time_from_start:
        buff.write(struct.pack('<2i', val1.secs, val1.nsecs))
      buff.write(struct.pack('<2d', self.command.max_velocity, self.command.max_acceleration))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.command is None:
        self.command = pr2_msgs.msg.LaserTrajCmd()
      end = 0
      start = end
      end += 12
      (self.command.header.seq, self.command.header.stamp.secs, self.command.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.command.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.command.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.command.profile
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.command.profile,) = struct.unpack(pattern, str[start:end])
      #deserialize self.command.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.command.position = struct.unpack(pattern, str[start:end])
      #deserialize self.command.time_from_start
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.command.time_from_start = []
      for i in xrange(0, length):
        val1 = roslib.rostime.Duration()
        start = end
        end += 8
        (val1.secs, val1.nsecs,) = struct.unpack('<2i',str[start:end])
        self.command.time_from_start.append(val1)
      start = end
      end += 16
      (self.command.max_velocity, self.command.max_acceleration,) = struct.unpack('<2d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.command.header.seq, self.command.header.stamp.secs, self.command.header.stamp.nsecs))
      length = len(self.command.header.frame_id)
      #serialize self.command.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.command.header.frame_id))
      length = len(self.command.profile)
      #serialize self.command.profile
      buff.write(struct.pack('<I%ss'%length, length, self.command.profile))
      #serialize self.command.position
      length = len(self.command.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.command.position.tostring())
      #serialize self.command.time_from_start
      length = len(self.command.time_from_start)
      buff.write(struct.pack('<I', length))
      for val1 in self.command.time_from_start:
        buff.write(struct.pack('<2i', val1.secs, val1.nsecs))
      buff.write(struct.pack('<2d', self.command.max_velocity, self.command.max_acceleration))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.command is None:
        self.command = pr2_msgs.msg.LaserTrajCmd()
      end = 0
      start = end
      end += 12
      (self.command.header.seq, self.command.header.stamp.secs, self.command.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.command.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.command.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.command.profile
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.command.profile,) = struct.unpack(pattern, str[start:end])
      #deserialize self.command.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.command.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.command.time_from_start
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.command.time_from_start = []
      for i in xrange(0, length):
        val1 = roslib.rostime.Duration()
        start = end
        end += 8
        (val1.secs, val1.nsecs,) = struct.unpack('<2i',str[start:end])
        self.command.time_from_start.append(val1)
      start = end
      end += 16
      (self.command.max_velocity, self.command.max_acceleration,) = struct.unpack('<2d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from SetLaserTrajCmdResponse.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime

class SetLaserTrajCmdResponse(roslib.message.Message):
  _md5sum = "3888666920054f1ef39d2df7a5d94b02"
  _type = "pr2_msgs/SetLaserTrajCmdResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """time start_time

"""
  __slots__ = ['start_time']
  _slot_types = ['time']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   start_time
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetLaserTrajCmdResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.start_time is None:
        self.start_time = roslib.rostime.Time()
    else:
      self.start_time = roslib.rostime.Time()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<2I', self.start_time.secs, self.start_time.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.start_time is None:
        self.start_time = roslib.rostime.Time()
      end = 0
      start = end
      end += 8
      (self.start_time.secs, self.start_time.nsecs,) = struct.unpack('<2I',str[start:end])
      self.start_time.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<2I', self.start_time.secs, self.start_time.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.start_time is None:
        self.start_time = roslib.rostime.Time()
      end = 0
      start = end
      end += 8
      (self.start_time.secs, self.start_time.nsecs,) = struct.unpack('<2I',str[start:end])
      self.start_time.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class SetLaserTrajCmd(roslib.message.ServiceDefinition):
  _type          = 'pr2_msgs/SetLaserTrajCmd'
  _md5sum = '28fe2ce397611c999952c74a1ea882aa'
  _request_class  = SetLaserTrajCmdRequest
  _response_class = SetLaserTrajCmdResponse
